Index: trunk/examples/extended/field/field04/include/F04RunAction.hh
===================================================================
--- trunk/examples/extended/field/field04/include/F04RunAction.hh	(revision 1187)
+++ trunk/examples/extended/field/field04/include/F04RunAction.hh	(revision 1230)
@@ -56,4 +56,6 @@
     G4int GetRndmFreq()          {return saveRndm;}
 
+    inline void SetAutoSeed (const G4bool val) {autoSeed = val;}
+
   private:
  
@@ -61,4 +63,6 @@
 
     G4int saveRndm;
+    G4bool autoSeed;
+
 };
 
Index: trunk/examples/extended/field/field04/include/F04RunActionMessenger.hh
===================================================================
--- trunk/examples/extended/field/field04/include/F04RunActionMessenger.hh	(revision 1187)
+++ trunk/examples/extended/field/field04/include/F04RunActionMessenger.hh	(revision 1230)
@@ -43,4 +43,5 @@
 class G4UIcmdWithAnInteger;
 class G4UIcmdWithAString;
+class G4UIcmdWithABool;
 
 class F04RunActionMessenger : public G4UImessenger
@@ -59,5 +60,6 @@
     G4UIdirectory*             RndmDir;
     G4UIcmdWithAnInteger*      RndmSaveCmd;    
-    G4UIcmdWithAString*        RndmReadCmd;    
+    G4UIcmdWithAString*        RndmReadCmd;
+    G4UIcmdWithABool*          SetAutoSeedCmd;
  
 };
Index: trunk/examples/extended/field/field04/src/F04Materials.cc
===================================================================
--- trunk/examples/extended/field/field04/src/F04Materials.cc	(revision 1187)
+++ trunk/examples/extended/field/field04/src/F04Materials.cc	(revision 1230)
@@ -94,9 +94,5 @@
   elements.push_back("H");     natoms.push_back(10);
 
-  // density = 1.032*g/cm3; 
-  // ==> when using ConstructNewMaterial give the density in g/cm3
-  // ==> but do NOT multiply by the unit!!!
-
-  density = 1.032;
+  density = 1.032*g/cm3;;
 
   Sci = nistMan->
Index: trunk/examples/extended/field/field04/src/F04PhysicsList.cc
===================================================================
--- trunk/examples/extended/field/field04/src/F04PhysicsList.cc	(revision 1187)
+++ trunk/examples/extended/field/field04/src/F04PhysicsList.cc	(revision 1230)
@@ -31,48 +31,5 @@
 
 #include "F04ExtraPhysics.hh"
-//#include "F04OpticalPhysics.hh"
-
-#include "G4DecayPhysics.hh"
-
-#include "G4EmStandardPhysics_option1.hh"
-#include "G4EmStandardPhysics_option2.hh"
-#include "G4EmStandardPhysics.hh"
-
-#include "G4EmExtraPhysics.hh"
-#include "G4EmProcessOptions.hh"
-
-#include "G4HadronElasticPhysics.hh"
-#include "G4HadronQElasticPhysics.hh"
-#include "G4HadronHElasticPhysics.hh"
-#include "G4NeutronTrackingCut.hh"
-#include "G4QStoppingPhysics.hh"
-#include "G4LHEPStoppingPhysics.hh"
-#include "G4IonBinaryCascadePhysics.hh"
-#include "G4IonPhysics.hh"
-
-#include "HadronPhysicsFTFP.hh"
-#include "HadronPhysicsFTFC.hh"
-
-#include "HadronPhysicsLHEP.hh"
-#include "HadronPhysicsLHEP_BERT.hh"
-#include "HadronPhysicsLHEP_EMV.hh"
-#include "HadronPhysicsLHEP_PRECO_HP.hh"
-
-#include "HadronPhysicsQGSC.hh"
-#include "HadronPhysicsQGSC_EFLOW.hh"
-
-#include "HadronPhysicsQGSP.hh"
-#include "HadronPhysicsQGSP_BERT.hh"
-#include "HadronPhysicsQGSP_BERT_HP.hh"
-#include "HadronPhysicsQGSP_BERT_TRV.hh"
-#include "HadronPhysicsQGSP_BIC.hh"
-#include "HadronPhysicsQGSP_BIC_HP.hh"
-
-#include "G4HadronInelasticQBBC.hh"
-#include "G4HadronInelasticQLHEP.hh"
-
-#include "G4IonPhysics.hh"
-
-#include "G4HadronProcessStore.hh"
+#include "G4OpticalPhysics.hh"
 
 #include "G4LossTableManager.hh"
@@ -81,4 +38,6 @@
 #include "G4ParticleTypes.hh"
 #include "G4ParticleTable.hh"
+
+#include "G4PhysListFactory.hh"
 
 #include "G4Gamma.hh"
@@ -105,19 +64,28 @@
     fCutForElectron  = defaultCutValue;
     fCutForPositron  = defaultCutValue;
-    fDump            = false;
 
     fMessenger = new F04PhysicsListMessenger(this);
 
-    fEMPhysics     = new PhysicsListVector();
-    fHadronPhysics = new PhysicsListVector();
-
-    // Particles
-    fParticleList = new G4DecayPhysics("decays");
-
-    // EM physics
-    AddPhysicsList("emstandard_opt1");
-
-    // Set the default hadronic physics.
-    AddPhysicsList(physicsList);
+    SetVerboseLevel(1);
+
+    G4PhysListFactory factory;
+    G4VModularPhysicsList* phys = 0;
+
+    if(factory.IsReferencePhysList(physicsList))
+      phys =factory.GetReferencePhysList(physicsList);
+
+    // Physics List is defined via environment variable PHYSLIST
+    if(!phys) phys = factory.ReferencePhysList();
+
+    for (G4int i = 0; ; ++i) {
+       G4VPhysicsConstructor* elem =
+                  const_cast<G4VPhysicsConstructor*> (phys->GetPhysics(i));
+       if (elem == NULL) break;
+       G4cout << "RegisterPhysics: " << elem->GetPhysicsName() << G4endl;
+       RegisterPhysics(elem);
+    }
+
+    RegisterPhysics(new F04ExtraPhysics());
+    RegisterPhysics(new G4OpticalPhysics());
 
     stepMaxProcess = new F04StepMax();
@@ -127,36 +95,11 @@
 {
     delete fMessenger;
-    delete fParticleList;
-
-    ClearEMPhysics();
-    ClearHadronPhysics();
-
-    delete fEMPhysics;
-    delete fHadronPhysics;
 
     delete stepMaxProcess;
 }
 
-void F04PhysicsList::ClearEMPhysics()
-{
-    for (PhysicsListVector::iterator p  = fEMPhysics->begin();
-                                     p != fEMPhysics->end(); ++p) {
-        delete (*p);
-    }
-    fEMPhysics->clear();
-}
-
-void F04PhysicsList::ClearHadronPhysics()
-{
-    for (PhysicsListVector::iterator p  = fHadronPhysics->begin();
-                                     p != fHadronPhysics->end(); ++p) {
-        delete (*p);
-    }
-    fHadronPhysics->clear();
-}
-
 void F04PhysicsList::ConstructParticle()
 {
-    fParticleList->ConstructParticle();
+    G4VModularPhysicsList::ConstructParticle();
 
     G4DecayTable* MuonPlusDecayTable = new G4DecayTable();
@@ -173,17 +116,9 @@
                             G4MuonRadiativeDecayChannelWithSpin("mu-",0.014));
     G4MuonMinus::MuonMinusDefinition() -> SetDecayTable(MuonMinusDecayTable);
-
 }
 
 void F04PhysicsList::ConstructProcess()
 {
-    AddTransportation();
-
-    for (PhysicsListVector::iterator p  = fEMPhysics->begin();
-                                     p != fEMPhysics->end(); ++p) {
-        (*p)->ConstructProcess();
-    }
-
-    fParticleList->ConstructProcess();
+    G4VModularPhysicsList::ConstructProcess();
 
     G4DecayWithSpin* decayWithSpin = new G4DecayWithSpin();
@@ -243,22 +178,16 @@
     }
 
-    for (PhysicsListVector::iterator p  = fHadronPhysics->begin();
-                                     p != fHadronPhysics->end();++p) {
-        (*p)->ConstructProcess();
-    }
-
     AddStepMax();
-
-    if (fDump) G4HadronProcessStore::Instance()->Dump(1);
-}
-
-void F04PhysicsList::RemoveFromEMPhysicsList(const G4String& name)
+}
+
+/*
+void F04PhysicsList::RemoveFromPhysicsList(const G4String& name)
 {
     G4bool success = false;
-    for (PhysicsListVector::iterator p  = fEMPhysics->begin();
-                                     p != fEMPhysics->end(); ++p) {
+    for (G4PhysConstVector::iterator p  = physicsVector->begin();
+                                     p != physicsVector->end(); ++p) {
         G4VPhysicsConstructor* e = (*p);
         if (e->GetPhysicsName() == name) {
-           fEMPhysics->erase(p);
+           physicsVector->erase(p);
            success = true;
            break;
@@ -267,282 +196,18 @@
     if (!success) {
        std::ostringstream message;
-       message << "PhysicsList::RemoveFromEMPhysicsList "<< name << "not found";
+       message << "PhysicsList::RemoveFromPhysicsList "<< name << "not found";
        G4Exception(message.str().c_str());
     }
 }
 
-void F04PhysicsList::RemoveFromHadronPhysicsList(const G4String& name)
-{
-    G4bool success = false;
-    for (PhysicsListVector::iterator p  = fHadronPhysics->begin();
-                                     p != fHadronPhysics->end(); ++p) {
-        G4VPhysicsConstructor* e = (*p);
-        if (e->GetPhysicsName() == name) {
-           fHadronPhysics->erase(p);
-           success = true;
-           break;
-        }
-    }
-    if (!success) {
-       G4String message("F04PhysicsList::RemoveFromHadronPhysicsList \"");
-       message += name;
-       message += " not found \"";
-       G4Exception(message);
-    }
-}
-
-void F04PhysicsList::AddPhysicsList(const G4String& name)
-{
-    if (verboseLevel>0) {
-        G4cout << "F04PhysicsList::AddPhysicsList: <" << name 
-               << ">" << G4endl;
-    }
-
-    if (name == "emstandard_opt1") {
-
-       ClearEMPhysics();
-       fEMPhysics->push_back(new G4EmStandardPhysics_option1());
-       fEMPhysics->push_back(new F04ExtraPhysics());
-//       fEMPhysics->push_back(new F04OpticalPhysics());
-
-    } else if (name == "emstandard_opt2") {
-
-       ClearEMPhysics();
-       fEMPhysics->push_back(new G4EmStandardPhysics_option2());
-       fEMPhysics->push_back(new F04ExtraPhysics());
-//       fEMPhysics->push_back(new F04OpticalPhysics());
-
-   } else if (name == "FTFC") {
-
-       SetStandardList(false, false);
-       fHadronPhysics->push_back(new HadronPhysicsFTFC("hadron",true));
-
-    } else if (name == "FTFP") {
-
-       SetStandardList(false, false);
-       fHadronPhysics->push_back(new HadronPhysicsFTFP("hadron",true));
-
-    } else if (name == "FTFP_EMV") {
-
-       AddPhysicsList("emstandard_opt1");
-       AddPhysicsList("FTFP");
-
-    } else if (name == "LHEP") {
-
-       ClearHadronPhysics();
-       fHadronPhysics->push_back(new G4EmExtraPhysics("gamma_nuc"));
-       fHadronPhysics->push_back(new G4HadronElasticPhysics("LElastic",
-                                                           verboseLevel,
-                                                           false));
-       fHadronPhysics->push_back(new HadronPhysicsLHEP("hadron"));
-       fHadronPhysics->push_back(new G4IonPhysics("ion"));
-       fDump = true;
- 
-    } else if (name == "LHEP_BERT") {
-
-       ClearHadronPhysics();
-       fHadronPhysics->push_back(new G4EmExtraPhysics("gamma_nuc"));
-       fHadronPhysics->push_back(new G4HadronElasticPhysics("LElastic",
-                                                           verboseLevel,
-                                                           false));
-       fHadronPhysics->push_back(new HadronPhysicsLHEP_BERT("hadron"));
-       fHadronPhysics->push_back(new G4QStoppingPhysics("stopping",
-                                                       verboseLevel));
-       fHadronPhysics->push_back(new G4IonPhysics("ion"));
-       fDump = true;
-
-    } else if (name == "LHEP_EMV") {
-
-       ClearHadronPhysics();
-       AddPhysicsList("emstandard_opt1");
-       fHadronPhysics->push_back(new G4EmExtraPhysics("gamma_nuc"));
-       fHadronPhysics->push_back(new G4HadronElasticPhysics("LElastic",
-                                                           verboseLevel,
-                                                           false));
-       fHadronPhysics->push_back(new HadronPhysicsLHEP_EMV("hadron"));
-       fHadronPhysics->push_back(new G4QStoppingPhysics("stopping",
-							verboseLevel));
-       fHadronPhysics->push_back(new G4IonPhysics("ion"));
-       fDump = true;
-
-    } else if (name == "LHEP_PRECO_HP") {
-
-       ClearHadronPhysics();
-       fHadronPhysics->push_back(new G4EmExtraPhysics("gamma_nuc"));
-       fHadronPhysics->push_back(new G4HadronElasticPhysics("LElastic",
-                                                           verboseLevel,
-                                                           false));
-       fHadronPhysics->push_back(new HadronPhysicsLHEP_PRECO_HP("hadron"));
-       fHadronPhysics->push_back(new G4QStoppingPhysics("stopping",
-                                                       verboseLevel));
-       fHadronPhysics->push_back(new G4IonPhysics("ion"));
-       fDump = true;
-
-    } else if (name == "QBBC") {
-
-       SetStandardList(false,true);
-       fHadronPhysics->push_back(new G4HadronInelasticQBBC("QBBC",
-                                                          verboseLevel,
-                                                          false,false,
-                                                          false,false,true));
-
-    } else if (name == "QBBCG") {
-
-       SetStandardList(false, false);
-       fHadronPhysics->push_back(new G4HadronInelasticQBBC("QBBC",
-                                                          verboseLevel,
-                                                          false,false,
-                                                          false,false,false));
-
-    } else if (name == "QBEC") {
-
-       SetStandardList(false,true);
-       fHadronPhysics->push_back(new G4HadronInelasticQBBC("QBBC",
-                                                          verboseLevel,
-                                                          false,true,
-                                                          false,false,true));
-
-    } else if (name == "QBBC_HP") {
-
-       SetStandardList(true,true);
-       fHadronPhysics->push_back(new G4HadronInelasticQBBC("QBBC",
-                                                          verboseLevel,
-                                                          false,false,
-                                                          false,true,true));
-
-    } else if (name == "QBEC_HP") {
-
-       SetStandardList(true,true);
-       fHadronPhysics->push_back(new G4HadronInelasticQBBC("QBBC",
-                                                          verboseLevel,
-                                                          false,true,
-                                                          false,true,true));
-
-    } else if (name == "QGSC") {
-
-       ClearHadronPhysics();
-       fHadronPhysics->push_back(new G4EmExtraPhysics("gamma_nuc"));
-       fHadronPhysics->push_back(new G4HadronQElasticPhysics("QElastic",
-                                                            verboseLevel));
-       fHadronPhysics->push_back(new HadronPhysicsQGSC("hadron",true));
-       fHadronPhysics->push_back(new G4QStoppingPhysics("stopping",
-                                                       verboseLevel,false));
-       fHadronPhysics->push_back(new G4IonPhysics("ion"));
-       fHadronPhysics->push_back(new G4NeutronTrackingCut());
-       fDump = true;
-
-    } else if (name == "QGSC_EFLOW") {
-
-       ClearHadronPhysics();
-       fHadronPhysics->push_back(new G4EmExtraPhysics("gamma_nuc"));
-       fHadronPhysics->push_back(new G4HadronQElasticPhysics("QElastic",
-                                                            verboseLevel));
-       fHadronPhysics->push_back(new HadronPhysicsQGSC_EFLOW("hadron",true));
-       fHadronPhysics->push_back(new G4QStoppingPhysics("stopping",
-                                                       verboseLevel,false));
-       fHadronPhysics->push_back(new G4IonPhysics("ion"));
-       fHadronPhysics->push_back(new G4NeutronTrackingCut());
-       fDump = true;
-
-    } else if (name == "QGSC_EMV") {
-
-       AddPhysicsList("emstandard_opt1");
-       AddPhysicsList("QGSC");
-
-    } else if (name == "QGSP") {
-
-       SetStandardList(false, false);
-       fHadronPhysics->push_back(new HadronPhysicsQGSP("hadron",true));
-
-    } else if (name == "QGSP_BERT") {
-
-       SetStandardList(false, false);
-       fHadronPhysics->push_back(new HadronPhysicsQGSP_BERT("hadron",true));
-
-    } else if (name == "QGSP_BERT_EMV") {
-
-       AddPhysicsList("emstandard_opt1");
-       AddPhysicsList("QGSP_BERT");
-
-    } else if (name == "QGSP_BERT_HP") {
-
-       SetStandardList(true, false);
-       fHadronPhysics->push_back(new HadronPhysicsQGSP_BERT_HP("hadron",true));
-
-    } else if (name == "QGSP_BERT_NQE") {
-
-       SetStandardList(false, false);
-       fHadronPhysics->push_back(new HadronPhysicsQGSP_BERT("hadron",false));
-
-    } else if (name == "QGSP_BERT_TRV") {
-
-       SetStandardList(false, false);
-       fHadronPhysics->push_back(new HadronPhysicsQGSP_BERT_TRV("hadron",true));
-
-    } else if (name == "QGSP_BIC") {
-
-       SetStandardList(false, false);
-       fHadronPhysics->push_back(new HadronPhysicsQGSP_BIC("hadron",true));
-
-    } else if (name == "QGSP_BIC_HP") {
-
-       SetStandardList(true, false);
-       fHadronPhysics->push_back(new HadronPhysicsQGSP_BIC_HP("hadron",true));
-
-    } else if (name == "QGSP_EMV") {
-
-       AddPhysicsList("emstandard_opt1");
-       AddPhysicsList("QGSP");
-
-    } else if (name == "QGSP_EMV_NQE") {
-
-       AddPhysicsList("emstandard_opt1");
-       AddPhysicsList("QGSP_NQE");
-
-    } else if (name == "QGSP_EMX") {
-
-       AddPhysicsList("emstandard_opt2");
-       AddPhysicsList("QGSP");
-
-    } else if (name == "QGSP_NQE") {
-
-       SetStandardList(false, false);
-       fHadronPhysics->push_back(new HadronPhysicsQGSP("hadron",false));
-
-    } else if (name == "QGSP_QEL") {
-
-       ClearHadronPhysics();
-       fHadronPhysics->push_back(new G4EmExtraPhysics("gamma_nuc"));
-       fHadronPhysics->push_back(new G4HadronQElasticPhysics("QElastic",
-                                                            verboseLevel));
-       fHadronPhysics->push_back(new HadronPhysicsQGSP("hadron",true));
-       fHadronPhysics->push_back(new G4QStoppingPhysics("stopping",
-                                                       verboseLevel));
-       fHadronPhysics->push_back(new G4IonPhysics("ion"));
-       fHadronPhysics->push_back(new G4NeutronTrackingCut());
-       fDump = true;
-
-    } else {
-
-       G4cout << "F04PhysicsList::AddPhysicsList: <" << name << ">"
-              << " is not defined" << G4endl;
-    }
-}
-
-void F04PhysicsList::SetStandardList(G4bool flagHP, G4bool glauber)
-{
-    ClearHadronPhysics();
-
-    fHadronPhysics->push_back(new G4EmExtraPhysics("gamma_nuc"));
-    fHadronPhysics->push_back(new G4HadronElasticPhysics("elastic",
-                                                        verboseLevel,
-                                                        flagHP,glauber));
-    fHadronPhysics->push_back(new  G4QStoppingPhysics("stopping",
-                                                     verboseLevel));
-    fHadronPhysics->push_back(new G4IonBinaryCascadePhysics("binary_ion"));
-    fHadronPhysics->push_back(new G4NeutronTrackingCut());
-
-    fDump = true;
-}
+void F04PhysicsList::ClearPhysics()
+{
+    for (G4PhysConstVector::iterator p  = physicsVector->begin();
+                                     p != physicsVector->end(); ++p) {
+        delete (*p);
+    }
+    physicsVector->clear();
+}
+*/
 
 void F04PhysicsList::SetCuts()
@@ -581,25 +246,4 @@
 }
 
-void F04PhysicsList::List()
-{
-    G4cout << "### PhysicsLists available: FTFC FTFP FTFP_EMV"
-           << " LHEP LHEP_BERT LHEP_EMV"
-           << G4endl;
-    G4cout << "                            LHEP_PRECO_HP QBBC QBBCG"
-           << " QBEC QBBC_HP QBEC_HP"
-           << G4endl;
-    G4cout << "                            QGSC QGSC_EFLOW QGSC_EMV"
-           << " QGSP QGSP_BERT QGSP_BER_EMV"
-           << G4endl;
-    G4cout << "                            QGSP_BERT_HP QGSP_BERT_NQE"
-           << " QGSP_BERT_TRV"
-           << G4endl;
-    G4cout << "                            QGSP_BIC QGSP_BIC_HP QGSP_EMV"
-           << " QGSP_EMV_NQE"
-           << G4endl;
-    G4cout << "                            QGSC_EMX QGSP_NQE QGSP_QEL"
-           << G4endl;
-}
-
 void F04PhysicsList::SetStepMax(G4double step)
 {
Index: trunk/examples/extended/field/field04/src/F04PhysicsListMessenger.cc
===================================================================
--- trunk/examples/extended/field/field04/src/F04PhysicsListMessenger.cc	(revision 1187)
+++ trunk/examples/extended/field/field04/src/F04PhysicsListMessenger.cc	(revision 1230)
@@ -87,32 +87,14 @@
     fStepMaxCMD->SetDefaultUnit("mm");
     fStepMaxCMD->AvailableForStates(G4State_PreInit,G4State_Idle);
+/*
+    fClearPhysicsCMD = new G4UIcmdWithoutParameter("/exp/phys/clearPhysics",this);
+    fClearPhysicsCMD->SetGuidance("Clear the physics list");
+    fClearPhysicsCMD->AvailableForStates(G4State_PreInit,G4State_Idle);
 
-    fAddPhysicsCMD = new G4UIcmdWithAString("/exp/phys/addPhysics",this);
-    fAddPhysicsCMD->SetGuidance("Add to modular physics list");
-    fAddPhysicsCMD->SetParameterName("PList",false);
-    fAddPhysicsCMD->AvailableForStates(G4State_PreInit,G4State_Idle);
-
-    fClearEMPhysicsCMD = new G4UIcmdWithoutParameter("/exp/phys/clearEMPhysics",this);
-    fClearEMPhysicsCMD->SetGuidance("Clear the EM physics list");
-    fClearEMPhysicsCMD->AvailableForStates(G4State_PreInit,G4State_Idle);
-
-    fClearHadronPhysicsCMD = new G4UIcmdWithoutParameter("/exp/phys/clearHadronPhysics",this);
-    fClearHadronPhysicsCMD->SetGuidance("Clear the Hadron physics list");
-    fClearHadronPhysicsCMD->AvailableForStates(G4State_PreInit,G4State_Idle);
-
-    fRemoveEMPhysicsCMD = new G4UIcmdWithAString("/exp/phys/removeEMPhysics",this);
-    fRemoveEMPhysicsCMD->SetGuidance("Remove a physics process from EM Physics List");
-    fRemoveEMPhysicsCMD->SetParameterName("PList",false);
-    fRemoveEMPhysicsCMD->AvailableForStates(G4State_PreInit,G4State_Idle);
-
-    fRemoveHadronPhysicsCMD = new G4UIcmdWithAString("/exp/phys/removeHadronPhysics",this);
-    fRemoveHadronPhysicsCMD->SetGuidance("Remove a physics process from Hadron Physics List");
-    fRemoveHadronPhysicsCMD->SetParameterName("PList",false);
-    fRemoveHadronPhysicsCMD->AvailableForStates(G4State_PreInit,G4State_Idle);
-
-    fListCMD = new G4UIcmdWithoutParameter("/exp/phys/list",this);
-    fListCMD->SetGuidance("Available Physics Lists");
-    fListCMD->AvailableForStates(G4State_PreInit,G4State_Idle);
-
+    fRemovePhysicsCMD = new G4UIcmdWithAString("/exp/phys/removePhysics",this);
+    fRemovePhysicsCMD->SetGuidance("Remove a physics process from Physics List");
+    fRemovePhysicsCMD->SetParameterName("PList",false);
+    fRemovePhysicsCMD->AvailableForStates(G4State_PreInit,G4State_Idle);
+*/
     fDecayDirectory = new G4UIdirectory("/decay/");
     fDecayDirectory->SetGuidance("Decay chain control commands.");
@@ -132,13 +114,8 @@
     delete fPosCutCMD;
     delete fAllCutCMD;
-
-    delete fAddPhysicsCMD;
-    delete fClearEMPhysicsCMD;
-    delete fClearHadronPhysicsCMD;
-    delete fRemoveEMPhysicsCMD;
-    delete fRemoveHadronPhysicsCMD;
-
-    delete fListCMD;
-
+/*
+    delete fClearPhysicsCMD;
+    delete fRemovePhysicsCMD;
+*/
     delete fPienuCMD;
     delete fPimunuCMD;
@@ -191,34 +168,11 @@
                                      ->GetNewDoubleValue(newValue));
     }
-    else if (command == fAddPhysicsCMD) {
+/*  else if (command == fClearPhysicsCMD) {
+        fPhysicsList->ClearPhysics();
+    }
+    else if (command == fRemovePhysicsCMD) {
         G4String name = newValue;
-        if (name == "PHYSLIST") {
-            char* path = getenv(name);
-            if (path) name = G4String(path);
-            else {
-                G4cout << "### F04PhysicsListMessenger WARNING: "
-                       << " environment variable PHYSLIST is not defined"
-                       << G4endl;
-                return; 
-            }
-        }
-        fPhysicsList->AddPhysicsList(name);
+        fPhysicsList->RemoveFromPhysicsList(name);
     }
-    else if (command == fClearEMPhysicsCMD) {
-        fPhysicsList->ClearEMPhysics();
-    }
-    else if (command == fClearHadronPhysicsCMD) {
-        fPhysicsList->ClearHadronPhysics();
-    }
-    else if (command == fRemoveEMPhysicsCMD) {
-        G4String name = newValue;
-        fPhysicsList->RemoveFromEMPhysicsList(name);
-    }
-    else if (command == fRemoveHadronPhysicsCMD) {
-        G4String name = newValue;
-        fPhysicsList->RemoveFromHadronPhysicsList(name);
-    }
-    else if (command == fListCMD) {
-        fPhysicsList->List();
-    }
+*/
 }
Index: trunk/examples/extended/field/field04/src/F04RunAction.cc
===================================================================
--- trunk/examples/extended/field/field04/src/F04RunAction.cc	(revision 1187)
+++ trunk/examples/extended/field/field04/src/F04RunAction.cc	(revision 1230)
@@ -38,5 +38,5 @@
 
 F04RunAction::F04RunAction()
-  : saveRndm(0)
+  : saveRndm(0), autoSeed(false)
 {
   runMessenger = new F04RunActionMessenger(this);
@@ -54,10 +54,21 @@
   G4RunManager::GetRunManager()->SetRandomNumberStore(true);
   G4RunManager::GetRunManager()->SetRandomNumberStoreDir("random/");
+
+  if (autoSeed) {
+     // automatic (time-based) random seeds for each run
+     G4cout << "*******************" << G4endl;
+     G4cout << "*** AUTOSEED ON ***" << G4endl;
+     G4cout << "*******************" << G4endl;
+     long seeds[2];
+     time_t systime = time(NULL);
+     seeds[0] = (long) systime;
+     seeds[1] = (long) (systime*G4UniformRand());
+     CLHEP::HepRandom::setTheSeeds(seeds);
+     CLHEP::HepRandom::showEngineStatus();
+  } else {
+     CLHEP::HepRandom::showEngineStatus();
+  }
   
-  if (saveRndm > 0)
-  { 
-      CLHEP::HepRandom::showEngineStatus();
-      CLHEP::HepRandom::saveEngineStatus("BeginOfRun.rndm");
-  }
+  if (saveRndm > 0) CLHEP::HepRandom::saveEngineStatus("BeginOfRun.rndm");
 
   FieldList* fields = F04GlobalField::getObject()->getFields();
@@ -73,6 +84,5 @@
 void F04RunAction::EndOfRunAction(const G4Run*)
 {
-  if (saveRndm == 1)
-  { 
+  if (saveRndm == 1) {
      CLHEP::HepRandom::showEngineStatus();
      CLHEP::HepRandom::saveEngineStatus("endOfRun.rndm");
Index: trunk/examples/extended/field/field04/src/F04RunActionMessenger.cc
===================================================================
--- trunk/examples/extended/field/field04/src/F04RunActionMessenger.cc	(revision 1187)
+++ trunk/examples/extended/field/field04/src/F04RunActionMessenger.cc	(revision 1230)
@@ -33,4 +33,5 @@
 #include "G4UIcmdWithAnInteger.hh"
 #include "G4UIcmdWithAString.hh"
+#include "G4UIcmdWithABool.hh"
 
 #include "F04RunAction.hh"
@@ -57,21 +58,32 @@
   RndmReadCmd->SetParameterName("fileName",true);
   RndmReadCmd->SetDefaultValue ("beginOfRun.rndm");
-  RndmReadCmd->AvailableForStates(G4State_PreInit,G4State_Idle);  
+  RndmReadCmd->AvailableForStates(G4State_PreInit,G4State_Idle);
+
+  SetAutoSeedCmd = new G4UIcmdWithABool("/rndm/autoSeed",this);
+  SetAutoSeedCmd->SetGuidance("Switch on/off time-based random seeds");
+  SetAutoSeedCmd->SetGuidance(" true: run seeds determined by system time");
+  SetAutoSeedCmd->SetGuidance("false: use command 'random/resetEngineFrom'");
+  SetAutoSeedCmd->SetGuidance("Default = false");
+  SetAutoSeedCmd->SetParameterName("autoSeed", false);
+  SetAutoSeedCmd->AvailableForStates(G4State_PreInit,G4State_Idle);
 }
 
 F04RunActionMessenger::~F04RunActionMessenger()
 { 
-  delete RndmDir; delete RndmSaveCmd; delete RndmReadCmd;
+  delete RndmDir; delete RndmSaveCmd; delete RndmReadCmd; delete SetAutoSeedCmd;
 }
 
-void F04RunActionMessenger::SetNewValue(G4UIcommand* command,G4String newValues)
+void F04RunActionMessenger::SetNewValue(G4UIcommand* command,G4String newValue)
 {
   if (command == RndmSaveCmd)
-      runAction->SetRndmFreq(RndmSaveCmd->GetNewIntValue(newValues));
+      runAction->SetRndmFreq(RndmSaveCmd->GetNewIntValue(newValue));
 		 
   if (command == RndmReadCmd)
-  {  G4cout << "\n---> rndm status restored from file: " << newValues << G4endl;
-     CLHEP::HepRandom::restoreEngineStatus(newValues);
+  {  G4cout << "\n---> rndm status restored from file: " << newValue << G4endl;
+     CLHEP::HepRandom::restoreEngineStatus(newValue);
      CLHEP::HepRandom::showEngineStatus();
-  }   
+  }
+
+  if(command == SetAutoSeedCmd)
+      runAction->SetAutoSeed(SetAutoSeedCmd->GetNewBoolValue(newValue));
 }
Index: trunk/examples/extended/g3tog4/clGeometry/clGeometry.cc
===================================================================
--- trunk/examples/extended/g3tog4/clGeometry/clGeometry.cc	(revision 1187)
+++ trunk/examples/extended/g3tog4/clGeometry/clGeometry.cc	(revision 1230)
@@ -26,5 +26,5 @@
 //
 // $Id: clGeometry.cc,v 1.7 2006/06/29 17:20:00 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // 
Index: trunk/examples/extended/g3tog4/clGeometry/include/G3toG4DetectorConstruction.hh
===================================================================
--- trunk/examples/extended/g3tog4/clGeometry/include/G3toG4DetectorConstruction.hh	(revision 1187)
+++ trunk/examples/extended/g3tog4/clGeometry/include/G3toG4DetectorConstruction.hh	(revision 1230)
@@ -26,5 +26,5 @@
 //
 // $Id: G3toG4DetectorConstruction.hh,v 1.4 2006/06/29 17:20:03 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 #ifndef G3toG4DetectorConstruction_h
Index: trunk/examples/extended/g3tog4/clGeometry/include/G3toG4EventAction.hh
===================================================================
--- trunk/examples/extended/g3tog4/clGeometry/include/G3toG4EventAction.hh	(revision 1187)
+++ trunk/examples/extended/g3tog4/clGeometry/include/G3toG4EventAction.hh	(revision 1230)
@@ -26,5 +26,5 @@
 //
 // $Id: G3toG4EventAction.hh,v 1.3 2006/06/29 17:20:05 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // 
Index: trunk/examples/extended/g3tog4/clGeometry/include/G3toG4EventActionMessenger.hh
===================================================================
--- trunk/examples/extended/g3tog4/clGeometry/include/G3toG4EventActionMessenger.hh	(revision 1187)
+++ trunk/examples/extended/g3tog4/clGeometry/include/G3toG4EventActionMessenger.hh	(revision 1230)
@@ -26,5 +26,5 @@
 //
 // $Id: G3toG4EventActionMessenger.hh,v 1.3 2006/06/29 17:20:07 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // 
Index: trunk/examples/extended/g3tog4/clGeometry/include/G3toG4PhysicsList.hh
===================================================================
--- trunk/examples/extended/g3tog4/clGeometry/include/G3toG4PhysicsList.hh	(revision 1187)
+++ trunk/examples/extended/g3tog4/clGeometry/include/G3toG4PhysicsList.hh	(revision 1230)
@@ -26,5 +26,5 @@
 //
 // $Id: G3toG4PhysicsList.hh,v 1.3 2006/06/29 17:20:09 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // 
Index: trunk/examples/extended/g3tog4/clGeometry/include/G3toG4PrimaryGeneratorAction.hh
===================================================================
--- trunk/examples/extended/g3tog4/clGeometry/include/G3toG4PrimaryGeneratorAction.hh	(revision 1187)
+++ trunk/examples/extended/g3tog4/clGeometry/include/G3toG4PrimaryGeneratorAction.hh	(revision 1230)
@@ -26,5 +26,5 @@
 //
 // $Id: G3toG4PrimaryGeneratorAction.hh,v 1.3 2006/06/29 17:20:11 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 
Index: trunk/examples/extended/g3tog4/clGeometry/include/G3toG4RunAction.hh
===================================================================
--- trunk/examples/extended/g3tog4/clGeometry/include/G3toG4RunAction.hh	(revision 1187)
+++ trunk/examples/extended/g3tog4/clGeometry/include/G3toG4RunAction.hh	(revision 1230)
@@ -26,5 +26,5 @@
 //
 // $Id: G3toG4RunAction.hh,v 1.3 2006/06/29 17:20:13 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 
Index: trunk/examples/extended/g3tog4/clGeometry/src/G3toG4DetectorConstruction.cc
===================================================================
--- trunk/examples/extended/g3tog4/clGeometry/src/G3toG4DetectorConstruction.cc	(revision 1187)
+++ trunk/examples/extended/g3tog4/clGeometry/src/G3toG4DetectorConstruction.cc	(revision 1230)
@@ -26,5 +26,5 @@
 //
 // $Id: G3toG4DetectorConstruction.cc,v 1.5 2006/06/29 17:20:15 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //--------------------------------------------------------------------------
